#!/usr/bin/python

import Tkinter
from Tkinter import *


from tkCommonDialog import Dialog


import myglobal
from myglobal import g as Global



#
#
#  choix des couleurs 
# 
#
class Chooser(Dialog):
    "Ask for a color"
    command = "tk_chooseColor"
    def _fixoptions(self):
        try:
            # make sure initialcolor is a tk color string
            color = self.options["initialcolor"]
            if type(color) == type(()):
                # assume an RGB triplet
                self.options["initialcolor"] = "#%02x%02x%02x" % color
        except KeyError:
            pass

    def _fixresult(self, widget, result):
        # to simplify application code, the color chooser returns
        # an RGB tuple together with the Tk color string
        if not result:
            return None, None # canceled
        r, g, b = widget.winfo_rgb(result)
        return (r/256, g/256, b/256), result



def askcolor(color = None, **options):
    "Ask for a color"
    if color:
        options = options.copy()
        options["initialcolor"] = color
    return apply(Chooser, (), options).show()







def EcritureConfig():
	Global.save()
        return 1


def ChercheExecutablePovray():
    import os,os.path,glob
    homedir = os.path.expanduser('~')
    for start in [homedir+'povray',homedir+'/*/povray','/usr/local/bin/povray','/usr/local/share/*/povray','/usr/bin/povray']:
        for f in glob.glob(start):
            if os.path.isfile(f) and os.access(f,os.X_OK) and  os.path.split(f)[1] == 'povray' :
                return f
    return "Rien Trouv..."

def ChercheLibrairiesPovray():
    import os,os.path,glob
    homedir = os.path.expanduser('~')
    for start in [homedir+'/*',homedir+'/*/*',homedir+'/*/*/*','/usr/local/lib/*','/usr/local/lib/*/*','/usr/local/lib/*/*/*','/usr/lib/*','/usr/lib/*/*','/usr/lib/*/*/*']:
        for f in glob.glob(start):
            if os.path.isfile(f) and  os.path.split(f)[1] == 'arrays.inc':
                return   os.path.split(f)[0]
            if os.path.isfile(f) and  os.path.split(f)[1] == 'colors.inc':
                return   os.path.split(f)[0]
    return "Rien Trouv..."



def Detection(num = None,ed=None):
    if num == 0 : ed.insert(0,ChercheExecutablePovray())
    if num == 1 : ed.insert(0,ChercheLibrairiesPovray())

def Selection(ed=None,type=None):
    if type == 0 : #selection fichier
        import tkFileDialog
        f = tkFileDialog.Open()
        fname = f.show()
        if not fname : return
        ed.delete(0,'end')
        ed.insert(0,fname)
    if type == 1 : #selection repertoire
        import tkFileDialog
        f = tkFileDialog.Open()
        fname = f.show()
        if not fname : return
        ed.delete(0,'end')
        ed.insert(0,fname)






class App:
    def __init__(self, master,a,VariableBlocageDetection):
        self.master = master
        self.VariableBlocageDetection=VariableBlocageDetection
        self.fr = {}
        self.e = {}
        self.b1 = {}
        self.b2 = {}
        self.label = {}
        self.mess = ["Exec. pov       ","Include pov    ","Includes perso"]

        if a == 1 :
            self.toplevel = Frame(master)
            #self.frame.grid(row=0,column=0)
        else :
            self.toplevel = Toplevel(master)
        #self.frame.grid(row=0,column=0)
        
        str1 = "Povedit doit connaitre quelques adresses pour fonctionner correctement.\nVous pouvez taper directement ces adresses dans les fenetres d'dition.\nVous pouvez galement cliquer le bouton Recherche ,une recherche automatique sera alors effectue.\nVous pouvez enfin cliquer les  boutons selection, pour rechercher vous meme ces adresses.\n\nPovedit must know some adresses to run corectly.\nYou can directly type these adresses in the entries.\nYou can too click the button \"search\", povedit will proceed to an automatic research.\nYou can too use the button \"Select\" to explore your filesystem "

        self.message = Text(self.toplevel,bg='white',height=10)
        self.message.insert(0.1,str1)
        self.message.tag_add("popo",1.0,2.0)
        self.message.tag_add("popo",6.0,7.0)
        self.message.tag_configure("popo", foreground = 'red',relief = GROOVE)
        self.message.grid(row = 0,column = 0,columnspan=4,pady=15,padx=15)


        #adresse de povray
        self.fr[0] = Frame(self.toplevel,width=20,relief='sunken')
        self.label[0] = Label(self.fr[0],text=self.mess[0])
        self.label[0].grid(row = 0 ,column = 0 ,sticky="e" )
        self.e[0] = Entry(self.fr[0],width = 35)
        self.e[0].grid(row = 0 ,column = 1,sticky="ew")
        self.b1[0]=Button(self.fr[0],text="Autodetection",command=lambda a=self.e[0]:Detection(0,a))
        self.b1[0].grid(row = 0 ,column = 2 )
        self.b2[0] = Button(self.fr[0],text="Selection",command = lambda a=self.e[0]  : Selection(a,0))
        self.b2[0].grid(row = 0 ,column = 3 ,sticky="e" )
        self.fr[0].grid(row = 0 + 1,column = 0,columnspan=2)

        #adresse des includes de  povray
        self.fr[1] = Frame(self.toplevel,width=20,relief='sunken')
        self.label[1] = Label(self.fr[1],text=self.mess[1])
        self.label[1].grid(row = 0 ,column = 0 ,sticky="e" )
        self.e[1] = Entry(self.fr[1],width = 35)
        self.e[1].grid(row = 0 ,column = 1,sticky="ew")
        self.b1[1]=Button(self.fr[1],text="Autodetection",command=lambda a=self.e[1]:Detection(1,a))
        self.b1[1].grid(row = 0 ,column = 2 )
        self.b2[1] = Button(self.fr[1],text="Selection",command = lambda a=self.e[1]  : Selection(a,1))
        self.b2[1].grid(row = 0 ,column = 3 ,sticky="e" )
        self.fr[1].grid(row = 1 + 1,column = 0,columnspan=2)
        #adresse des includes perso
        self.fr[2] = Frame(self.toplevel,width=20,relief='sunken')
        self.label[2] = Label(self.fr[2],text=self.mess[2])
        self.label[2].grid(row = 0 ,column = 0 ,sticky="e" )
        self.e[2] = Entry(self.fr[2],width = 35)
        self.e[2].grid(row = 0 ,column = 1,sticky="ew")
        self.b1[2]=Button(self.fr[2],text="Autodetection",command=lambda a=self.e[2]:Detection(2,a))
        self.b1[2].grid(row = 0 ,column = 2 )
        self.b2[2] = Button(self.fr[2],text="Selection",command = lambda a=self.e[2]  : Selection(a,1))
        self.b2[2].grid(row = 0 ,column = 3 ,sticky="e" )
        self.fr[2].grid(row = 2 + 1,column = 0,columnspan=2)




        #choix du langage
	self.Varlang = IntVar(Global.langue)
	self.LabelLangage = Label(self.toplevel,text="Langue")
	self.RB1 = Radiobutton(self.toplevel,variable=self.Varlang ,value=0,text="Francais")
	self.RB2 = Radiobutton(self.toplevel,variable=self.Varlang ,value=1,text="Anglais")
	self.LabelLangage.grid(row = 4,column = 0,rowspan=2,sticky=W+E)
	self.RB1.grid(row = 4,column = 1)
	self.RB2.grid(row = 5,column = 1)


	
	#police
	self.LabelPolice = Label(self.toplevel,text="Police : "+repr(Global.police),font =Global.police )
	self.ButtonPolice = Button(self.toplevel,text="Modifier",command=self.selectfont)
	self.LabelPolice.grid(row = 6,column = 0)
	self.ButtonPolice .grid(row = 6,column =1)

	#couleur
	self.LabelCouleur = Label(self.toplevel,text="Couleur : ")
	self.ButtonCouleur = Button(self.toplevel,text="Modifier",command=self.selectcolor)
	self.LabelCouleur.grid(row = 7,column = 0)
	self.ButtonCouleur .grid(row = 7,column =1)



	self.ButtonOK = Button(self.toplevel,text='OK',command=self.buttoncommand)
	self.ButtonOK.grid(row = 8,column =0)
	self.ButtonCancel = Button(self.toplevel,text='Cancel',command=self.buttoncancel)
	self.ButtonCancel.grid(row = 8,column =1)

        if Global.AdresseDePOV != '' :
            self.e[0].insert(0,  Global.AdresseDePOV)
        else :
            self.e[0].insert(0, ChercheExecutablePovray())
            
        if Global.AdresseIncludesPourPOV != '' :
            self.e[1].insert( 0, Global.AdresseIncludesPourPOV)
        else :
            self.e[1].insert( 0,ChercheLibrairiesPovray())
        
        
        if Global.IncludesPersonnels != '' :
            self.e[2].insert(0,  Global.IncludesPersonnels)


        self.toplevel.geometry("678x438+0+0")







    def selectfont(self):
        from fontselect import fontselect as fontselect
        fs = fontselect(self.toplevel)
        self.toplevel.wait_window( fs.tl )
        self.LabelPolice.configure(text="Police : %s"%repr(Global.police),font=Global.police)
        self.toplevel.update_idletasks()
    
    def selectcolor(self):
	    x = Global.maincolor
	    Global.maincolor =  askcolor()[1]

	
        #self.bok =  Button(self.toplevel,text=" OK ",command = self.buttoncommand).grid(row = 6,column = 1)



        
    def buttoncancel(self):
        #self.toplevel.destroy()
        self.toplevel.withdraw()
        self.VariableBlocageDetection.set(1)
        
    def buttoncommand(self):
        import tkMessageBox
        from tkMessageBox import showerror,showinfo
        import os.path
        ad0 = self.e[0].get()
        ad1 = self.e[1].get()
        ad2 = self.e[2].get()
        if not os.path.isdir(ad1) : ad1 = os.path.split(ad1)[0]
        if not os.path.isdir(ad2) : ad2 = os.path.split(ad2)[0]
        if not os.path.isdir(ad2) : ad2 = os.path.split(ad2)[0]
        if not os.path.isfile(ad0)  :
            showerror('Erreur', 'Adresse povray invalide')
            return
        if not os.path.isdir(ad1)  :
            showerror('Erreur', 'Adresse include\n pour pov invalide')
            return
        print  self.Varlang.get()
        Global.AdresseDePOV = ad0
        Global.AdresseIncludesPourPOV = ad1
        Global.IncludesPersonnels = ad2
        Global.langue = self.Varlang.get()
	Global.save()
        self.toplevel.withdraw()
        self.VariableBlocageDetection.set(1)

if __name__ == "__main__" :
    #root = Tk()
    app = App(None)
    app.frame.mainloop()
    #root.geometry("600x400+0+0")
    #root.mainloop()
